﻿using HarmonyLib;
using System;
using UnityEngine;
using System.IO;

public class PaintEverything : Mod
{
    AssetBundle asset;
    Material templateMat;
    Texture WoodPaintableTexture;
    Texture PlasticPaintableTexture;
    public void Start()
    {
        asset = AssetBundle.LoadFromMemory(GetEmbeddedFileBytes("painteverything.assets"));
        templateMat = ItemManager.GetItemByName("Block_Wall_Fence_Plank").settings_buildable.GetBlockPrefab(0).GetComponentInChildren<Renderer>().material;
        PlasticPaintableTexture = asset.LoadAsset<Texture>("plastic");
        WoodPaintableTexture = asset.LoadAsset<Texture>("wood");

        int i = 0;
        foreach (Item_Base item in ItemManager.GetAllItems())
        {
            if (item.settings_buildable.HasBuildablePrefabs)
            {
                foreach (Block b in (Block[])Traverse.Create(item.settings_buildable).Field("blockPrefabs").GetValue())
                {
                    if (!item.settings_buildable.Paintable) { i++; MakeBlockPaintable(item); break; }
                }
            }
        }
        Debug.Log("[PaintEverything] Detected " + i + " non paintable blocks, they are now paintable! Enjoy COLOOOORS!");
        Debug.Log("PaintEverything has been successfully initialized!");
    }

    // TEST COMMAND :
    // csrun Debug.Log(ItemManager.GetItemByName("Placeable_Anchor_Stationary").settings_buildable.GetBlockPrefab(0).GetComponentsInChildren<Renderer>()[0].material.shader);
    public void MakeBlockPaintable(Item_Base placeable)
    {
        foreach (Block b in (Block[])Traverse.Create(placeable.settings_buildable).Field("blockPrefabs").GetValue())
        {
            try
            {
                foreach (Renderer r in b.GetComponentsInChildren<Renderer>())
                {
                    Traverse.Create(placeable.settings_buildable).Field("primaryPaintAxis").SetValue(Axis.All);
                    if (r.material.shader.name == "Standard")
                    {
                        Material paintableMat = r.material;
                        paintableMat.shader = templateMat.shader;
                        paintableMat.SetTexture("_Diffuse", paintableMat.GetTexture("_MainTex"));
                        paintableMat.SetTexture("_Normal", paintableMat.GetTexture("_BumpMap"));
                        paintableMat.SetTexture("_MetallicRPaintMaskGSmoothnessA", WoodPaintableTexture);
                        r.material = paintableMat;
                    }
                    else if (r.material.shader.name == "Vegetation")
                    {
                        Material paintableMat = r.material;
                        paintableMat.shader = templateMat.shader;
                        paintableMat.SetTexture("_Diffuse", paintableMat.GetTexture("_Diffuse"));
                        paintableMat.SetTexture("_Normal", paintableMat.GetTexture("_Normal"));
                        paintableMat.SetTexture("_MetallicRPaintMaskGSmoothnessA", WoodPaintableTexture);
                        r.material = paintableMat;
                    }
                }
            }
            catch { /* Nice Update 13 fix isn't it ? */ }
        }
    }
}